// Header.cpp
/*
Copyright (C) 2003  Anders Hedstrom

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#include <string.h>
#include <ctype.h>

#include "Header.h"
#include "Parse.h"
#include "list.h"


Header::Header(void)
{
	headerbase = NULL;
	current = NULL;
	dataindex = 0;
}

Header::Header(char *s,int l)
{
	HEADER *c,*tmp;
	Parse *pa = new Parse(s,";");
	Parse *pa2;
	char *slask = new char[l + 1];
	char *name = new char[l + 1];
	char *value = new char[l + 1];
	int i,ok = 1;

	headerbase = NULL;
	current = NULL;
	dataindex = 0;

	pa -> getline(slask);
	while (*slask)
	{
		for (i = 0; i < (int)strlen(slask); i++)
			if (!isprint(slask[i]) && slask[i] != 13 && slask[i] != 10 && slask[i] != 9)
			{
//printf("Don't like char %d\n",slask[i]);
				ok = 0;
			}

		pa2 = new Parse(slask);
		pa2 -> getword(name);
		pa2 -> getrest(value);
		delete pa2;
		c = new HEADER;
		c -> name = new char[strlen(name) + 1];
		strcpy(c -> name,name);
		c -> value = new char[strlen(value) + 1];
		strcpy(c -> value,value);
		addlistl(&headerbase,c);
		pa -> getline(slask);
	}
	dataindex = pa -> getptr(); // 1st char after last empty header line
	delete pa;
	delete slask;
	delete name;
	delete value;

	if (!ok)
	{
		for (c = headerbase; c; c = tmp)
		{
			delete c -> name;
			delete c -> value;
			tmp = c -> next;
			delete c;
		}
		headerbase = NULL;
	}
}

Header::~Header(void)
{
	HEADER *c,*tmp;

	for (c = headerbase; c; c = tmp)
	{
		delete c -> name;
		delete c -> value;
		tmp = c -> next;
		delete c;
	}
}

int Header::getvalue(char *name,char *buffer,short length)
{
	HEADER *c;

	for (c = headerbase; c; c = c -> next)
		if (!strcasecmp(c -> name,name))
			break;
	if (c)
	{
		if ((short)strlen(c -> value) >= length)
		{
			strncpy(buffer,c -> value,length - 1);
			buffer[length - 1] = 0;
		} else
			strcpy(buffer,c -> value);
		return 1;
	} else
	{
		*buffer = 0;
		return 0;
	}
}

void Header::replacevalue(char *name,char *value)
{
	HEADER *c;
	
	for (c = headerbase; c; c = c -> next)
		if (!strcasecmp(c -> name,name))
			break;

	if (c)
	{
		if (strlen(value) > strlen(c -> value))
		{
			delete c -> value;
			c -> value = new char[strlen(value) + 1];
		}
		strcpy(c -> value,value);
	} else
	{
		c = new HEADER;
		c -> name = new char[strlen(name) + 1];
		strcpy(c -> name,name);
		c -> value = new char[strlen(value) + 1];
		strcpy(c -> value,value);
		addlistl(&headerbase,c);
	}
}

int Header::getlength(char *name)
{
	HEADER *c;

	for (c = headerbase; c; c = c -> next)
		if (!strcasecmp(c -> name,name))
			break;
	return c ? strlen(c -> value) : 0;
}

/* get names */

void Header::getfirst(char *n,short len)
{
	current = headerbase;
	getnext(n,len);
}

void Header::getnext(char *n,short len)
{
	if (current)
	{
		strncpy(n,current -> name,len - 1);
		n[len - 1] = 0;
		current = current -> next;
	} else
		*n = 0;
}

