// Lst.cpp
/*
Copyright (C) 2003  Anders Hedstrom

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#include <stdio.h>
#include <string.h>

#include "Lst.h"

Lst::Lst(void) 
{
	base = NULL;
	qty = 0;
}

Lst::~Lst(void) 
{
}

void Lst::addlist(void *it) 
{
	LST *item = (LST *)it;
	item -> next = base;
	base = item;
	qty++;
}

void Lst::removelist(void *it) 
{
	LST *q = base;
	LST *prev = NULL;
	while (q && q != (LST *)it)
	{
		prev = q;
		q = q -> next;
	}
	if (q)
	{
		if (!prev)
			base = q -> next;
		else
			prev -> next = q -> next;
		qty--;
	}
}

void *Lst::num2ptr(long num) 
{
	LSTNUM *q = (LSTNUM *)base;
	while (q && q -> num != num)
		q = q -> next;
	return (void *)q;
}

void *Lst::char2ptr(char *s) 
{
	LSTCHAR *q = (LSTCHAR *)base;
	while (q && strcmp(q -> s,s))
		q = q -> next;
	return (void *)q;
}

void *Lst::charptr2ptr(char *s) 
{
	LSTCHARPTR *q = (LSTCHARPTR *)base;
	while (q && strcmp(q -> s,s))
		q = q -> next;
	return (void *)q;
}

long Lst::len(void) 
{ 
	return qty; 
}
